Skip to content

Latest commit

 

History

History
72 lines (66 loc) · 3.22 KB

README.md

File metadata and controls

72 lines (66 loc) · 3.22 KB

You are given an integer array nums and an integer k. Find the maximum subarray sum of all the subarrays of nums that meet the following conditions:

  • The length of the subarray is k, and
  • All the elements of the subarray are distinct.

Return the maximum subarray sum of all the subarrays that meet the conditions. If no subarray meets the conditions, return 0.

A subarray is a contiguous non-empty sequence of elements within an array.

 

Example 1:

Input: nums = [1,5,4,2,9,9,9], k = 3
Output: 15
Explanation: The subarrays of nums with length 3 are:
- [1,5,4] which meets the requirements and has a sum of 10.
- [5,4,2] which meets the requirements and has a sum of 11.
- [4,2,9] which meets the requirements and has a sum of 15.
- [2,9,9] which does not meet the requirements because the element 9 is repeated.
- [9,9,9] which does not meet the requirements because the element 9 is repeated.
We return 15 because it is the maximum subarray sum of all the subarrays that meet the conditions

Example 2:

Input: nums = [4,4,4], k = 3
Output: 0
Explanation: The subarrays of nums with length 3 are:
- [4,4,4] which does not meet the requirements because the element 4 is repeated.
We return 0 because no subarrays meet the conditions.

 

Constraints:

  • 1 <= k <= nums.length <= 105
  • 1 <= nums[i] <= 105

Companies: Amazon

Related Topics:
Array, Hash Table, Sliding Window

Similar Questions:

Solution 1.

// OJ: https://leetcode.com/problems/maximum-sum-of-distinct-subarrays-with-length-k
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(K)
class Solution {
public:
    long long maximumSubarraySum(vector<int>& A, int k) {
        unordered_map<int, int> cnt;
        long long sum = 0, N = A.size(), ans = 0;
        for (int i = 0; i < N; ++i) {
            sum += A[i];
            cnt[A[i]]++;
            if (i - k >= 0) {
                sum -= A[i - k];
                if (--cnt[A[i - k]] == 0) cnt.erase(A[i - k]);
            }
            if (cnt.size() == k) ans = max(ans, sum);
        }
        return ans;
    }
};